<template lang="pug">
  .container
    h1.mt-5 Login
    div
      .form__signin
        .form__signin--social.h-100
          .wrap-social-login
            .wrap-button
              button.btn.btn-primary.btn-facebook(
                type="button"
                @click="fbLogin"
                ) Login with Facebook
                fa.social-icon(:icon="['fab', 'facebook-square']")

            .wrap-button
              #google-signin-btn.mw-100.d-none
              button.btn.btn-primary.btn-google(
                type="button"
                @click="googleLogin"
                ) Sign in with Google
                img.social-image(src="/images/logo/btn_google_light_normal_ios.svg")


      .d-flex.align-items-center
        .line
        p.m-0.px-5 or
        .line

      .mt-4
        b-form(
          v-if="show"
          @reset='onReset'
          )
          b-form-group#input-group-1(
            label='Email:'
            label-for='input-1'
            description="We'll never share your email with anyone else."
            )
            b-form-input#input-1(
              v-model='form.email'
              type='email'
              required=''
              placeholder='Enter Email'
              )
          b-form-group#input-group-2(
            label='Password:'
            label-for='input-2'
            )
            b-form-input#input-2(
              type="password"
              v-model='form.password'
              required=''
              placeholder='Enter Password'
              )

          b-button.mr-2(
            type='button'
            variant='primary'
            @click='onSubmit'
            ) Submit
          b-button(
            type='reset'
            variant='outline-danger'
            ) Reset

</template>

<script>
import settings from '~/settings'
import { AuthServices } from '~/services'
import { mapActions } from 'vuex'

export default {
  data() {
    return {
      form: {
        email: 'admin@admin.com',
        password: '1234'
      },
      show: true,

      isClicked: false
    }
  },
  head() {
    return {
      title: "Login",
      meta: [
        {
          name: 'google-signin-client_id',
          content:
            '251088378284-rhkavhem822ndo3ei5e3kb47jk0ra75a.apps.googleusercontent.com',
          rel: 'preload'
        }
      ],
      script: [
        {
          src: 'https://apis.google.com/js/platform.js?onload=init',
          async: true,
          defer: true
        }
      ]
    }
  },
  async mounted() {
    let accessToken = ''
    if (this.$route.hash.split('#').join('')) {
      let queryString = this.$route.hash.split('#').join('')
      let token = new URLSearchParams(queryString)
      localStorage.setItem('accessToken', queryString)

      const facebook_response = await this.FacebookProfile(queryString)
      const { error, value } = await this.onUpdateProfile({
        token: '1234',
        profile: {
          name: facebook_response.username,
          lastName: facebook_response.lastname
        }
      })

      this.$router.push({ name: 'index' })
    }

    setTimeout(()=> {
      this.google_init()
    }, 1000)
  },
  methods: {
    ...mapActions('auth', ['onSignIn','onUpdateProfile']),

    // Connect Facebook
    fbLogin() {
      let login_uri = `${settings.website.baseURL}/auth/login`
      //window.open('https://www.facebook.com/v3.0/dialog/oauth?client_id=' + this.appId + '&display=page&response_type=token&auth_type=rerequest&scope=email&redirect_uri=' + this.uri, '_self')
      window.open(
        'https://www.facebook.com/v6.0/dialog/oauth?client_id=' +
          settings.og.app_id +
          '&display=page&response_type=token&auth_type=rerequest&scope=email&redirect_uri=' +
          login_uri,
        '_self'
      )
    },
    FacebookProfile(token) {
      return new Promise((resolve, reject) => {
        AuthServices.getFacebookProfile(token).then(res => {
          const user = {
            username: res.email,
            firstname: res.first_name,
            lastname: res.last_name,
            social_id: res.id,
            type: 'facebook'
          }
          // commit('SET_FACEBOOK_USER', user)
          resolve(user)
        })
      })
    },

    // Connect Google 

    googleLogin() {
      let button = document.querySelector('.abcRioButtonContentWrapper')
      button.click()
    },
    google_init() {
      gapi.load('auth2', () => {
        /* Ready. Make a call to gapi.auth2.init or some other API */
        gapi.auth2
          .init({
            client_id:
              '251088378284-rhkavhem822ndo3ei5e3kb47jk0ra75a.apps.googleusercontent.com'
          })
          .then(() => {
            this.onGoogleSignOut()
          })
        gapi.signin2.render('google-signin-btn', {
          // this is the button "id"
          onsuccess: this.onGoogleSignIn // note, no "()" here
        })
      })
    },

    async onGoogleSignIn(googleUser) {
      if (this.isClicked && googleUser) {
        var profile = googleUser.getBasicProfile()
        var id_token = googleUser.getAuthResponse().id_token
        let user = {
          google_id: profile.getId(),
          firstname: profile.getGivenName(),
          lastname: profile.getFamilyName(),
          email: profile.getEmail(),
          token: id_token
        }
        const { error, value } = await this.onUpdateProfile({
          token: id_token,
          profile: {
            name: user.email,
            lastName: user.lastname
          }
        })

        if (error) {
          console.log(error)
        }

        this.$router.push({ name: 'index' })
      }
    },
    onGoogleSignOut() {
      var auth2 = gapi.auth2.getAuthInstance()
      auth2.signOut().then(() => {
        this.isClicked = true
      })
    },

    // Connect Username
    async onSubmit(evt) {
      const { error, value } = await this.onSignIn(
        {
          username: this.form.email, 
          password: this.form.password
        }
      )
      this.$router.push({ name: 'index' })
    },
    onReset(evt) {
      evt.preventDefault()
      // Reset our form values
      this.form.email = ''
      this.form.password = ''
      // Trick to reset/clear native browser form validation state
      this.show = false
      this.$nextTick(() => {
        this.show = true
      })
    }
  }
}
</script>

<style lang="less" scoped>
.line {
  height: 1px;
  border-top: 1px solid #cccccc;
  width: 45%;
}

.form__signin {
  &--social {
    display: flex;
    flex-direction: column;
  }
  .wrap-button {
    width: 100%;
    margin: 1rem;
  }
  .btn {
    min-width: 273px;
    position: relative;
    font-weight: normal;
    &-facebook {
      font-family: 'Kanit';
      border: unset;
      background-color: #4464af;
      color: white;
      &:hover {
        background-color: darken(#4464af, 10%);
      }
      .social-icon {
        position: absolute;
        left: 8px;
        top: 50%;
        transform: translate(50%, -50%);
        font-size: 1.5rem;
      }
    }
    &-google {
      border: unset;
      font-family: 'Kanit';
      background-color: white;
      color: #333333;
      &:hover {
        background-color: #4285f4;
      }
      .social-image {
        position: absolute;
        left: 0;
        top: 0;
        height: 100%;
      }
    }
  }
}
</style>